import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Tank {
	public static final int XSPEED = 3;
	public static final int YSPEED = 3;
	public static final int TANK_WIDTH = 30;
	public static final int TANK_HEIGHT = 30;
	public static final int LIFE = 5;
	private static Random rNum = new Random();
	
	private Color col1 = Color.red;
	private Color col2 = Color.cyan;
	private TankWar tw = null;
	private int x,y;
	public int life;
	private BloodRec br = new BloodRec();
	
	private int step = rNum.nextInt(14) + 2;
	
	//public enum Direction {L, LU, U, RU, R, RD, D, LD, STOP};
	Direction dir = Direction.STOP, ptDir = Direction.D;
	public Direction[] dirs = Direction.values();
	
	boolean U = false, D = false, L = false, R = false, STOP = false;
	private boolean live = true;
	private boolean good = true;
	
	Missile m = null;
	
	public Tank(int x, int y , boolean good,Direction dir, int life, TankWar tw){
		this.x = x;
		this.y = y;
		this.good = good;
		this.tw = tw;
		this.dir = dir;
		this.life = life;
	}
	
	
	public Tank(int x, int y, TankWar tw) {
		this.x = x;
		this.y = y;
		this.tw = tw;
	}
	
	public void barrelDir(Graphics g){
		int x1 = x+Tank.TANK_WIDTH/2;
		int y1 = y+Tank.TANK_HEIGHT/2;
		int x2 = x1, y2 = y1;
		
		switch (ptDir){
		case L:
			x2 -= 5*XSPEED; break;
		case LU:
			x2 -= 4*XSPEED; y2 -= 4*YSPEED; break;
		case U:
			y2 -= 5*YSPEED; break;
		case RU:
			y2 -= 4*YSPEED; x2 += 4*XSPEED; break;
		case R:
			x2 += 5*XSPEED; break;
		case RD:
			x2 += 4*XSPEED; y2 += 4*YSPEED; break;
		case D:
			y2 += 5*YSPEED; break;
		case LD:
			y2 += 4*YSPEED; x2 -= 4*XSPEED; break;
		}
		Color c = g.getColor();
		g.setColor(Color.red);
		g.drawLine(x1, y1, x2, y2);
	}
	
	public void draw(Graphics g){
		if (!live){
			return;
		}
		Color c = g.getColor();
		switch (life){
		case 1: g.setColor(Color.blue); break;
		case 2: g.setColor(Color.LIGHT_GRAY); break;
		case 3: g.setColor(Color.orange); break;
		default: g.setColor(Color.PINK); break;
		}
		if(this.good == true) g.setColor(Color.white);
		
		br.draw(g);
		g.fillOval(x, y, TANK_WIDTH, TANK_HEIGHT);
		g.setColor(c);
		barrelDir(g);
		if(tw.tanks.size() <= 0)
			this.generateEnermy();
		move();
	}
	
	public void move(){
		
		if(this.good == false && rNum.nextInt(30)>28) {
				enermyFire();
		}
		switch (dir){
		case L: 
			x -= XSPEED; break;
		case LU: 
			x -= XSPEED; y -= YSPEED; break;
		case U:  
			y -= YSPEED; break;
		case RU:  
			y -= YSPEED; x += XSPEED; break;
		case R:  
			x += XSPEED; break;
		case RD:  
			x += XSPEED; y += YSPEED; break;
		case D:	 
			y += YSPEED; break;
		case LD:  
			y += YSPEED; x -= XSPEED; break;
		}
	
		setBounds();
		
		if(this.good == false){
			if(step == 0){
				dir = dirs[rNum.nextInt(dirs.length)];
				step = rNum.nextInt(14) + 2;
			}
			step --;
		}
		
		if(this.dir != Direction.STOP)
			this.ptDir = this.dir;
		this.live = this.isHit();
	}
	
	public void located (){
		if (!U & !D & L & !R) dir = Direction.L;
		if (U & !D & L & !R) dir = Direction.LU;
		if (U & !D & !L & !R) dir = Direction.U;
		if (U & !D & !L & R) dir = Direction.RU;
		if (!U & !D & !L & R) dir = Direction.R;
		if (!U & D & !L & R) dir = Direction.RD;
		if (!U & D & !L & !R) dir = Direction.D;
		if (!U & D & L & !R) dir = Direction.LD;
		if (!U & !D & !L & !R) dir = Direction.STOP;
	}
	
	
	public void keyPressed(KeyEvent e){
		int i = e.getKeyCode();
		switch (i){
		case KeyEvent.VK_UP: U = true; break;
		case KeyEvent.VK_DOWN:D = true; break;
		case KeyEvent.VK_LEFT:L = true; break;
		case KeyEvent.VK_RIGHT: R = true; break;
		}
		located();
		move();
	}
	
	public void keyReleased(KeyEvent ke){
		int i = ke.getKeyCode();
		switch (i){
		case KeyEvent.VK_UP: U = false; break;
		case KeyEvent.VK_DOWN:D = false; break;
		case KeyEvent.VK_LEFT:L = false; break;
		case KeyEvent.VK_RIGHT: R = false; break;
		case KeyEvent.VK_W : fire(); break;
		case KeyEvent.VK_F: superArm(); break;
		case KeyEvent.VK_F2: if(good) {
			this.life = LIFE; 
			this.setLive(true);
			this.col2 = Color.cyan;
		}
		}
		located();
	}

	public void fire(){
		if(!live) return;
		
		int X = x + (TANK_WIDTH - Missile.MISSILE_WIDTH)/2;
		int Y = y + (TANK_HEIGHT - Missile.MISSILE_HEIGHT)/2;
		m = new Missile(X, Y, ptDir, this.col2, this.tw); 
		tw.missiles.add(m);
	}
	
	public void fire(Direction dir){
		if(!live) return;
		
		int X = x + (TANK_WIDTH - Missile.MISSILE_WIDTH)/2;
		int Y = y + (TANK_HEIGHT - Missile.MISSILE_HEIGHT)/2;
		m = new Missile(X, Y, dir,Color.red, this.tw); 
		tw.missiles.add(m);
	}
	
	public void enermyFire(){
		int X = x + (TANK_WIDTH - Missile.MISSILE_WIDTH)/2;
		int Y = y + (TANK_HEIGHT - Missile.MISSILE_HEIGHT)/2;
		m = new Missile(X, Y, ptDir,Color.yellow, this.tw); 
		tw.enermyMissiles.add(m);
	}
	
	public void setBounds (){
		if (x < 0) x = 0;
		if (y < Tank.TANK_HEIGHT) y = Tank.TANK_HEIGHT;
		if (x > TankWar.WINDOW_WIDTH - Tank.TANK_WIDTH) x = TankWar.WINDOW_WIDTH -Tank.TANK_WIDTH;
		if (y > TankWar.WINDOW_HEIGHT - Tank.TANK_HEIGHT) y = TankWar.WINDOW_HEIGHT - Tank.TANK_HEIGHT;
		for(int i=0;i<tw.walls.size();i++){
			Wall w = tw.walls.get(i);
			if (this.wallCrashed(tw.walls.get(i))){
				if(x <= w.getX() - Tank.TANK_WIDTH + XSPEED)
					this.x = w.getX() - Tank.TANK_WIDTH;
				if(x >= w.getX() + Wall.WIDTH - XSPEED)
					this.x = w.getX() + Wall.WIDTH;
				if(y <= w.getY() - Tank.TANK_HEIGHT + YSPEED)
					this.y = w.getY() - Tank.TANK_HEIGHT;
				if(y >= w.getY() + Wall.HEIGHT -YSPEED)
					this.y = w.getY() + Wall.HEIGHT;
			}
		}
		
		for(int i=0;i<tw.tanks.size();i++){
			Tank t = tw.tanks.get(i);
			if(this.tankCrashed(t)){
				stay(t.getRec());
			}
			if(!this.equals(tw.tank) && this.tankCrashed(tw.tank))
				stay(tw.tank.getRec());
		}
		
	}
	
	public void stay(Rectangle r){
		if(x <= r.x - Tank.TANK_WIDTH + XSPEED)
			this.x = r.x - Tank.TANK_WIDTH;
		if(x >= r.x + r.width - XSPEED)
			this.x = r.x + r.width;
		if(y <= r.y - Tank.TANK_HEIGHT + YSPEED)
			this.y = r.y - Tank.TANK_HEIGHT;
		if(y >= r.y + r.height -YSPEED)
			this.y = r.y + r.height;
	}
	
	public void generateEnermy(){
		if(tw.enermyGrp>0){
			for(int i=1; i<10;i++)
				tw.tanks.add(new Tank(rNum.nextInt(800), rNum.nextInt(600), false, Direction.R, rNum.nextInt(3)+1, tw));
			tw.enermyGrp --;
		}
		else return;
	}
	
	public boolean isHit() {
		if (this.good == false && !tw.missiles.isEmpty()){
			for (int i=0;i<this.tw.missiles.size();i++){
				Missile m = tw.missiles.get(i);
				double x1 = m.getPoint().getX() + Missile.MISSILE_WIDTH/2;
				double y1 = m.getPoint().getY() + Missile.MISSILE_HEIGHT/2;
				double x2 = this.x + Tank.TANK_WIDTH/2;
				double y2 = this.y + Tank.TANK_HEIGHT/2;
				double dSqlt = (x2 - x1)*(x2 - x1) +  (y2 - y1)*(y2 - y1);
				double rSqlt = Tank.TANK_WIDTH/2 * Tank.TANK_WIDTH/2;
				if (dSqlt <= rSqlt) {
					if(Color.cyan == m.getColor()) life --;
					if(Color.RED == m.getColor())  life -= 2; 
					if(this.life <= 0){
						live = false;
						tw.tanks.remove(this);
						Explode bomb = new Explode(x,y,tw);
						tw.explodes.add(bomb);
					}
					m.setLive(false);
					if(tw.tanks.size()<3)
						this.generateEnermy();
				}
	
			}
		}
		return live;
	}
	
	public Rectangle getRec(){
		return new Rectangle(x, y, TANK_WIDTH, TANK_HEIGHT);
	}
	
	private boolean wallCrashed(Wall w){
		if(this.getRec().intersects(w.getRec())){
			return true;
		}
		return false;
	}
	
	private boolean tankCrashed(Tank t){
		if(this.getRec().intersects(t.getRec())){
			return true;
		}
		return false;
	}
	
	public void eatBlood(Blood b){
		if(this.good && this.getRec().intersects(b.getRec()) && this.isLive() && b.isLive()){
			this.life = LIFE;
			b.setLive(false);
			this.col2 = this.col1;
		}
	}
	
	public boolean isLive(){
		return live;
	}
	
	public void setLive(boolean live) {
		this.live = live;
	}
	
	public void superArm(){
		for (int i=0;i<dirs.length - 1;i++){
			fire(dirs[i]);
		}
	}
	
	private class BloodRec{
		public void draw(Graphics g){
			if(!live || !good) return;
			Color c = g.getColor();
			g.setColor(Color.WHITE);
			g.drawRect(x, y-5, TANK_WIDTH, 5);
			g.setColor(Color.red);
			g.fillRect(x, y-5, TANK_WIDTH * life / LIFE, 5);
			g.setColor(c);
		}
	}
	
}
